client/script = "<STYLE>BODY {background: black;color: white}</STYLE>"
world
	name = "3D Tag"
	turf = /turf/ground
	view = "6x6"
turf/ground
	icon = 'background.dmi'
	text = ""
obj/hands
	icon = 'hands.dmi'
	screen_loc = "3,1"
	layer = 50
obj/map_item
	layer = 49
obj/items/ladder
	icon = 'hole.dmi'
	text = "o"
obj/items/ladder_up
	icon = 'ladder.dmi'
	text = "H"
turf/wall
	icon = 'map_icons.dmi'
	icon_state = "wall"
	density = 1
	opacity = 1
	text = "#"
atom/proc/Bumped(atom/A)
mob/var/it

mob
	Bump(atom/A)
		..()
		A.Bumped(src)
	Bumped(mob/M)
		if(M.it)
			world << "<font color=yellow>[src] is now it!</font>"
			src << "<font color=red>You are now it!"
			src.it = 1
			M.it = 0
		else
			..()
obj/Compass
		icon = 'Compass.dmi'
		screen_loc = "6,6"
		layer = 111
obj/hand/layer = 50
obj/background
		icon = 'background.dmi'
		screen_loc = "1,1 to 6,3"
		layer = MOB_LAYER
mob
	verb
		say(t as text)
			if(src.it) world << "<b><font color=yellow>[src.name]</font>: [t]"
			else world << "<b><font color=red>[src.name]</font>: [t]"
obj/sky
	icon = 'background.dmi'
	icon_state = "sky"
	screen_loc = "1,4 to 6,6"
	layer = MOB_LAYER
obj/walls/wall/layer = MOB_LAYER+1
proc
	Update_Compass(mob/M as mob)
		for(var/obj/Compass/C in M.client.screen)
			C.icon_state = num2text(M.dir)
			if(C.icon_state=="1") C.text = "N"
			if(C.icon_state=="2") C.text = "S"
			if(C.icon_state=="4") C.text = "E"
			if(C.icon_state=="8") C.text = "W"
mob/Login()
	..()
	src.client.screen += new/obj/background
	src.client.screen += new/obj/sky
	src.client.screen += new/obj/Compass
	src.client.screen += new/obj/hands
	v_Move(src,9,6,2)
	src.dir = 1
	world << "[src] has entered 3D Tag."
	for(var/mob/CheckMob in world)
		if(CheckMob.it) CheckMob.it=0
	src.it=1
	world << "<font color=yellow>[src] is now it!</font>"
	Update_Compass(src)
mob/Logout()
	world << "[src] has logged out."
	if(src.it)
		var/list/people = new()
		for(var/mob/M in world) people+=M
		var/mob/M = pick(people);M.it = 1
		world << "<font color=yellow>[M] is it!</font>"
	..()
	del(src)

client
	East()
		mob.dir = turn(mob.dir,-90)
		Generate_Walls(mob)
		Update_Compass(mob)
	West()
		mob.dir = turn(mob.dir,90)
		Generate_Walls(mob)
		Update_Compass(mob)
	North()
		step(mob,mob.dir)
		Generate_Walls(mob)
	South()
		return
	Northeast()
		return
	Northwest()
		return
	Southeast()
		return
	Southwest()
		return
proc/check(var/T)
		if(istype(T,/turf/wall)) return 1
		else return 0
mob/verb
	Down()
		if(locate(/obj/items/ladder) in usr.loc)
			usr << "You climb down the hole."
			usr.z--;Generate_Walls(usr)
	Up()
		if(locate(/obj/items/ladder_up) in usr.loc)
			usr << "You climb up the ladder."
			usr.z++;Generate_Walls(usr)
mob
	icon = 'mob.dmi'
	text = "@"
obj/wall_obj
mob
	Move()
		..()
		for(var/mob/M in oview(2))
			if(M.client) Generate_Walls(M)

client
	New()
		..()
		var/obj/wall_obj/O
		for(var/i=1,i<7,i++)
			for(var/j=1,j<7,j++)
				O = new()
				screen += O
				O.screen_loc = "[i],[j]"
				mob.display_list[i][j] = O
				O.layer = 110
		Generate_Walls(mob)
mob/var/display_list[] = new(6,6)
proc
	Generate_Walls(mob/M as mob)
		for(var/obj/wall_obj/O in M.client.screen) O.icon_state = ""
		for(var/obj/wall_obj/O in M.client.screen)
			for(var/T in O.overlays) O.overlays -= T
		var/forward_right=get_step(M,turn(M.dir,-90))
		var/forward_left = get_step(M,turn(M.dir,90))
		var/forward_right1 = get_step(forward_right,M.dir)
		var/forward_left1 = get_step(forward_left,M.dir)
		var/forward_right_wall = get_step(M,turn(M.dir,-45))
		var/forward_left_wall = get_step(M,turn(M.dir,45))
		var/forward = get_step(M,M.dir)
		var/forward2 = get_step(forward,M.dir)
		var/forward2_left = get_step(forward2,turn(M.dir,90))
		var/forward2_right = get_step(forward2,turn(M.dir,-90))

		if(!check(forward2))
			if(check(forward2_left))
				Make_Wall('back.dmi',M)
				Make_Wall('back_corner.dmi',M)
			if(check(forward2_right))
				Make_Wall('back_right.dmi',M)
				Make_Wall('back_right_corner.dmi',M)
		if(check(forward2))
			Make_Wall('center3.dmi',M)
			if(check(forward2_right)&&!check(forward_right_wall)) Make_Wall('back_right.dmi',M)
			if(check(forward2_left)&&!check(forward_left_wall)) Make_Wall('back.dmi',M)
		if(!check(forward)&&!check(forward2))
			Make_Wall('out_of_range.dmi',M)
		if(!check(forward2_left)) Make_Wall('out_of_range_left.dmi',M)
		if(!check(forward2_right)) Make_Wall('out_of_range_right.dmi',M)
		if(check(forward_left)) Make_Wall('front.dmi',M,"0")
		if(check(forward_right)) Make_Wall('front.dmi',M,"5")
		if(check(forward_left1)) Make_Wall('center2.dmi',M,"1")
		if(check(forward_right1)) Make_Wall('center2.dmi',M,"4")
		if(check(forward_right_wall)&&!check(forward_right)) Make_Wall('center2.dmi',M,"5")
		if(check(forward_left_wall)&&!check(forward_left)) Make_Wall('center2.dmi',M,"0")
		if(check(forward))
			Make_Wall('center.dmi',M)
			if(!check(forward_right)) Make_Wall('center2.dmi',M,"5")
			if(!check(forward_left)) Make_Wall('center2.dmi',M,"0")
		for(var/obj/items/L in forward)
			Make_Object(L.icon,M)
			break
		if(!check(forward))
			for(var/mob/Mo in forward2)
				if(!Mo.it)
					Make_Object('mob2.dmi',M)
					break
				else
					Make_Object('mob_it2.dmi',M)
					break
		for(var/mob/Mo in forward)
			if(!Mo.it)
				Make_Object('mob.dmi',M)
				break
			else
				Make_Object('mob_it.dmi',M)
				break

proc
	Make_Object(var/I as icon,mob/M as mob,first_letter as text)
		var/obj/tempobj
		for(var/S in icon_states(I))
			var/first_num = text2num(copytext(S,1,2))
			var/second_num = text2num(copytext(S,3,4))
			if(first_letter)
				if(copytext(S,1,2)==first_letter)
					tempobj = M.display_list[first_num+1][second_num+1]
					tempobj.overlays += icon(I,"[first_num],[second_num]")
			else
				tempobj = M.display_list[first_num+1][second_num+1]
				tempobj.overlays += icon(I,"[first_num],[second_num]")
	Make_Wall(I as icon,mob/M as mob,first_letter as text)
		var/obj/tempobj
		if(first_letter)
			for(var/S in icon_states(I))
				if(copytext(S,1,2)==first_letter)
					var/first_num = text2num(copytext(S,1,2))
					var/second_num = text2num(copytext(S,3,4))
					tempobj = M.display_list[first_num+1][second_num+1]
					tempobj.icon = I
					tempobj.icon_state = "[first_num],[second_num]"
		else
			for(var/S in icon_states(I))
				var/first_num = text2num(copytext(S,1,2))
				var/second_num = text2num(copytext(S,3,4))
				tempobj = M.display_list[first_num+1][second_num+1]
				tempobj.icon = I
				tempobj.icon_state = "[first_num],[second_num]"
mob/var/list/display_objects = new()
proc
	v_Move(mob/target_mob as mob,destination_x as num,destination_y as num,destination_z as num)
		if(!destination_z) destination_z=target_mob.z
		for(var/turf/T in view(locate(destination_x,destination_y,destination_z)))
			if(target_mob.Move(T))
				..()
				break



